"plot.proflik" <-
  function(obj.proflik, pages = c("user", "one", "two"), uni.only = FALSE, bi.only = 
           F, type.bi = c("contour", "persp"),
           conf.int = c(0.90000000000000002,0.94999999999999996),
           yaxis.lims = c("conf.int", "as.computed"),
           by.col = TRUE, log.scale = FALSE, par.mar.persp = c(0, 0, 0, 0),
           ...)
                                        #
{
                                        #  par.mfrow.ori <- par()$mfrow
                                        #  par.mfcol.ori <- par()$mfcol
  pages <- match.arg(pages)
  if(all(is.character(yaxis.lims)))
    yaxis.lims <- match.arg(yaxis.lims)
  type.bi <- match.arg(type.bi)
  n.uni <- obj.proflik$n.uni
  n.bi <- obj.proflik$n.bi
  if(n.bi == 0)
    uni.only <- T
  if((uni.only == FALSE) & (bi.only == FALSE))
    np <- n.uni + n.bi
  if((uni.only == TRUE) & (bi.only == FALSE))
    np <- n.uni
  if((uni.only == FALSE) & (bi.only == TRUE))
    np <- n.bi
  if(n.uni==0 & np > 0) bi.only <- T
  if(n.bi==0 & np > 0) uni.only <- T
  if(pages == "one") {
    if(np >= 1 & np < 4)
      par(mfrow = c(np, 1))
    if(np >= 4) {
      if(by.col == TRUE)
        par(mfcol = c(ceiling(np/2), 2))
      else par(mfrow = c(ceiling(np/2), 2))
    }
  }
  if(pages == "two") {
    if(n.uni > 1 & n.uni < 4)
      par(mfrow = c(n.uni, 1))
    if(n.uni >= 4)
      par(mfrow = c(ceiling(n.uni/2), 2))
  }     
  if(bi.only == FALSE) {
    for(i in 1:n.uni) {
      if(obj.proflik$method == "ML")
        ylabm <- "profile log-likelihood"
      else ylabm <- "profile log-(restricted) likelihood"
      if(all(conf.int) != FALSE) {
        if(!is.numeric(conf.int) | any(conf.int > 1))
          stop("argument conf.int must be numerical (scalar or vector) with values between 0 and 1")
        conf.int.drop <- obj.proflik[[i]][[3]][2] - 0.5 * qchisq(conf.int,1)
      }
      if(all(is.character(yaxis.lims))){
        if(yaxis.lims == "conf.int")
          lik.lims <- c(min(conf.int.drop), 
                        obj.proflik[[i]][[3]][2])
        else lik.lims <- c(min(obj.proflik[[i]][[2]]),
                           obj.proflik[[i]][[3]][2])
      }
      else
        lik.lims <- yaxis.lims
      if(log.scale == TRUE) {
        plot(log(obj.proflik[[i]][[1]]), 
             obj.proflik[[i]][[2]], type = 
             "l", xlab = paste("log-", plot.proflik.aux1(names(obj.proflik[[i]])[1])), ylab = 
             ylabm, ylim = lik.lims, ...)
        lines(log(c(obj.proflik[[i]][[3]][1], obj.proflik[[i]][[3]][1])),
              c(min(lik.lims), obj.proflik[[i]][[3]][2]), lty = 2)
      }
      else {
        plot(obj.proflik[[i]][[1]], obj.proflik[[i]][[2]], type = "l", xlab = 
             plot.proflik.aux1(names(obj.proflik[[i]])[1]),
             ylab = ylabm, ylim = lik.lims,
             ...)
        lines(c(obj.proflik[[i]][[3]][1], 
                obj.proflik[[i]][[3]][1]),
              c(min(lik.lims), obj.proflik[[
                                            i]][[3]][2]), lty = 2)
      }
      abline(h = conf.int.drop, lty = 3)
    }
  }
  if(uni.only == FALSE) {
    if(pages == "two") {
      if(n.bi >= 1 & n.bi < 4)
        par(mfrow = c(n.bi, 1))
      if(n.bi >= 4)
        par(mfrow = c(ceiling(n.bi/2), 2))
    }
    for(i in 1:n.bi) {
      if(type.bi == "contour") {
        if(log.scale == TRUE) {
          contour(log(obj.proflik[[(n.uni + i)]][[1]]),
                  log(obj.proflik[[(n.uni + i)]][[2]]),
                  matrix(obj.proflik[[(n.uni + i)]][[3]],
                         ncol = length(obj.proflik[[(n.uni +i)]][[2]])),
                  xlab = paste("log-", plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][1]))),
                  ylab = paste("log-", plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][2]))),
                    ...)
          points(log(t(obj.proflik[[(n.uni + i)]][[4]][1:2])))
        }
        else {
          contour(obj.proflik[[(n.uni + i)]][[1]],
                  obj.proflik[[(n.uni + i)]][[2]],
                  matrix(obj.proflik[[(n.uni + i)]][[3]],
                         ncol = length(obj.proflik[[(n.uni + i)]][[2]])),
                  xlab = plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][1])),
                  ylab = plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][2])),
                  ...)
          points(t(obj.proflik[[(n.uni + i)]][[4]][1:2]))
        }
      }
      if(type.bi == "persp") {
        cat("For better visualisation arguments for the funtion `persp` can be passed.\nSome relevant argments are: theta, phi, r, d, anong others.\n Type help(persp) for a description of the options\n")
        par.mar.ori <- par()$mar
                                        #        par(mar = par.mar.persp)
        if(obj.proflik$method == "ML")
          zlabm <- 
            "profile log-likelihood"
        else zlabm <- "profile log-(restricted) likelihood"
        zlimm <- range(obj.proflik[[(n.uni +
                                     i)]][[3]])
        zlimm[1] <- 1.01 * zlimm[1]
        minlik <- min(obj.proflik[[(n.uni + i)]][[3]])
        if(log.scale == TRUE) {
          persp(log(obj.proflik[[(n.uni + i)]][[1]]),
                log(obj.proflik[[(n.uni + i)]][[2]]),
                matrix(obj.proflik[[(n.uni + i)]][[3]],
                       ncol = length(obj.proflik[[(n.uni + i)]][[2]])),
                xlab = plot.proflik.aux1(paste("log-", names(obj.proflik[[(n.uni + i)]][1]))),
                ylab = paste("log-", plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][2]))),
                zlab = zlabm, box = T, ...)
                                        #          pp1 <- perspp(x = log(c(obj.proflik[[(n.uni + i)]][[4]][1],
                                        #                          min( obj.proflik[[(n.uni + i)]][[1]]))[c(1, 1, 1, 2)]),
                                        #                        y = log(c(obj.proflik[[(n.uni + i)]][[4]][2],
                                        #                          min(obj.proflik[[(n.uni + i)]][[2]]))[c(1, 1, 2, 1)]),
                                        #                        z = c(minlik, obj.proflik[[(n.uni + i)]][[4]][3])[c(1, 2, 1, 1)], pp)
                                        #          segments(log(pp1$x[1]), log(pp1$y[1]), log(pp1$x[2]), log(pp1$y[2]),
                                        #                   lwd = 2)
        }
        else {
          persp(x = obj.proflik[[(n.uni + i)]][[1]],
                y = obj.proflik[[(n.uni + i)]][[2]],
                z = matrix(obj.proflik[[(n.uni + i)]][[3]],
                  ncol = length(obj.proflik[[(n.uni + i)]][[2]])),
                xlab = plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][1])),
                ylab = plot.proflik.aux1(names(obj.proflik[[(n.uni + i)]][2])),
                zlab = zlabm, box = TRUE, ...)
                                        #          pp1 <- perspp(x = c(obj.proflik[[(n.uni + i)]][[4]][1],
                                        #                          min(obj.proflik[[(n.uni + i)]][[1]]))[c(1, 1, 1, 2)],
                                        #                        y = c(obj.proflik[[(n.uni + i)]][[4]][2],
                                        #                          min(obj.proflik[[(n.uni + i)]][[2]]))[c(1, 1,2, 1)],
                                        #                        z = c(minlik, obj.proflik[[(n.uni + i)]][[4]][3])[c(1, 2, 1, 1)], pp)
                                        #          segments(pp1$x[1], pp1$y[1], pp1$x[2], pp1$y[2], lwd = 2)
        }
        par(mar=par.mar.ori)
      }
    }
  }
                                        #  par(mfrow=par.mfrow.ori)
                                        #  par(mfcol=par.mfcol.ori)
  return(invisible())
}

"plot.proflik.aux1" <-
  function(parameter.name)
{
  switch(parameter.name,
         range = expression(phi),
         sill = expression(sigma^2),
         nugget = expression(tau^2),
         nugget.rel = expression(tau^2[R]))
}
